#
# spec file for package ghc-broadcast-chan
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name broadcast-chan
Name:           ghc-%{pkg_name}
Version:        0.1.1
Release:        1.1
Summary:        Broadcast channel type that avoids 0 reader space leaks
License:        BSD-3-Clause
Group:          System/Libraries
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
A variation of "Control.Concurrent.Chan" from base, which allows to the easy
creation of broadcast channels without the space-leaks that may arise from
using 'Control.Concurrent.Chan.dupChan'. The 'Control.Concurrent.Chan.Chan'
type from "Control.Concurrent.Chan" consists of both a read and write end.
This presents a problem when one wants to have a broadcast channel that, at
times, has zero listeners. To write to a 'Control.Concurrent.Chan.Chan' there
must always be a read end and this read end will hold ALL messages alive until
read. The simple solution applied in this module is to separate read and write
ends. As a result, any messages written to the write end can be immediately
garbage collected if there are no active read ends, avoding space leaks.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}


%build
%ghc_lib_build


%install
%ghc_lib_install


%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)

%changelog
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.1.1 revision 0 with cabal2obs.
